const tsj = require("ts-json-schema-generator");
const fs = require("fs");

/** @type {import("ts-json-schema-generator/dist/src/Config").Config} */
const config = {
  path: "src/types/spec.d.ts",
  type: "*", // Or <type-name> if you want to generate schema for that one type only
  tsconfig: "./tsconfig.json"
};

const output_path = "../editor/public/schema.json";

const schema = tsj.createGenerator(config).createSchema(config.type);

schema.allOf = [
  {
    "$ref": "#/definitions/GraphgraSpec"
  }
];

const schemaString = JSON.stringify(schema, null, 2);
fs.writeFile(output_path, schemaString, (err) => {
  if (err) throw err;
});


// ./node_modules/.bin/ts-json-schema-generator --path 'src/types/network.d.ts' --type '*'