import { bin } from "d3-array";
import { select } from "./select";
const computeBins = (data, spec) => {
    // construct bin object and pass in options
    const binObj = bin()
        .value(d => select(d, spec.field));
    const binned = binObj(data);
    // return binned.map(b => b.map(d => ({...d, x0: b.x0, x1: b.x1})))
    const results = [];
    for (const outBin of binned) {
        for (const entry of outBin) {
            // @ts-ignore
            results.push(Object.assign(Object.assign({}, entry), { bin0: outBin.x0, bin1: outBin.x1 }));
        }
    }
    return results;
};
export { computeBins };
//# sourceMappingURL=bin.js.map