import { cross, max, zip } from "d3-array";
const flatten = (data, spec) => {
    const output = [];
    for (const row of data) {
        const iterables = spec.flatten.map((fieldName) => row[fieldName]);
        const maxIterableLength = max(iterables.map(l => l.length)); // this is a kludge: I think the d3 function has the wrong type signature
        for (let i = 0; i < maxIterableLength; i++) {
            const flattenedVals = iterables.map(iter => iter[i]);
            const flattenedValObj = Object.fromEntries(zip(spec.flatten, flattenedVals));
            output.push(Object.assign(Object.assign({}, row), flattenedValObj));
        }
    }
    return output;
};
const flattenCartesian = (data, spec) => {
    const output = [];
    for (const row of data) {
        const iterables = spec.flatten.map((fieldName) => row[fieldName]);
        const crossed = cross.apply(null, iterables);
        for (const combination of crossed) {
            const combinationVals = Object.fromEntries(zip(spec.flatten, combination));
            output.push(Object.assign(Object.assign({}, row), combinationVals));
        }
    }
    return output;
};
export { flatten };
//# sourceMappingURL=flatten.js.map