import { zip } from "d3-array";
import { aggregationFunctions } from "./aggregation";
const pivot = (data, spec) => {
    const grouped = new Map();
    for (const row of data) {
        const groupVals = spec.groupby.map(fieldName => row[fieldName]).join("_");
        if (!grouped.has(groupVals)) {
            grouped.set(groupVals, []);
        }
        grouped.get(groupVals).push(row);
    }
    const aggregation = aggregationFunctions[spec.op] || aggregationFunctions["sum"];
    const output = [];
    for (const groupVals of grouped.keys()) {
        const rows = grouped.get(groupVals);
        const pivotedRow = {};
        for (const field of spec.groupby) {
            pivotedRow[field] = rows[0][field];
        }
        const vals = new Map(); // vals[fieldName] is a list of values taken by this field
        for (const row of rows) {
            const pivotVal = row[spec.pivot];
            const val = row[spec.value];
            if (!vals.has(pivotVal)) {
                vals.set(pivotVal, []);
            }
            vals.get(pivotVal).push(val);
        }
        for (const pivotVal of vals.keys()) {
            pivotedRow[pivotVal] = aggregation(vals.get(pivotVal));
        }
        output.push(pivotedRow);
    }
    //console.log({output})
    return output;
};
// const joinedRow = Object.fromEntries(zip([...spec.groupBy, spec.], combination));
const Oldpivot = (data, spec) => {
    const output = [];
    const grouped = new Map();
    for (const row of data) {
        const groupField = spec.groupby[0];
        const groupVal = row[groupField];
        const groupVals = spec.groupby.map(fieldName => row[fieldName]).join("_");
        const pivotVal = row[spec.pivot];
        const val = row[spec.value];
        if (!grouped.has(groupVals)) {
            grouped.set(groupVals, new Map());
        }
        if (!grouped.get(groupVals).has(pivotVal)) {
            grouped.get(groupVals).set(pivotVal, []);
        }
        grouped.get(groupVals).get(pivotVal).push(val);
    }
    const aggregation = aggregationFunctions[spec.op] || aggregationFunctions["sum"];
    for (const groupVals of grouped.keys()) {
        const values = grouped.get(groupVals);
        const pivotedRow = Object.fromEntries(zip());
        for (const field of values.keys()) {
            pivotedRow[field] = aggregation(values.get(field));
        }
        // const joinedRow = Object.fromEntries(zip([...spec.groupBy, spec.], combination));
    }
    return grouped.values();
};
export { pivot };
//# sourceMappingURL=pivot.js.map