const isArray = (obj) => Object.prototype.toString.call(obj) === '[object Array]';
const select = (object, expression) => {
    if (!expression) {
        return [];
    }
    const indexes = expression.split(".");
    for (const index of indexes) {
        if (typeof (object) === "undefined") {
            return undefined;
        }
        if (isArray(object)) {
            object = object.map((d) => d[index]).flat();
            // or  use   return Array.prototype.concat(...arr); instead of flat
        }
        else if (index.includes("[")) {
            // part of expression includes an array index (e.g., "data[0]")
            const [field, rest] = index.split("[");
            const [numericalIndex] = rest.split("]");
            object = object[field][numericalIndex];
        }
        else {
            object = object[index]; // object might be an array here
        }
    }
    return object;
};
const selectNested = (object, expression) => {
    const indexes = expression.split(".");
    const results = [];
    for (const index of indexes) {
        if (isArray(object)) {
            // console.log("Array:", {object})
            object = [...object.map((d) => d[index])];
        }
        else {
            // console.log("Object:", {object})
            object = object[index]; // object might be an array here
        }
    }
    return object;
};
export { select, selectNested };
//# sourceMappingURL=select.js.map