var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { computeAggregation } from "./aggregation";
import { computeBins } from "./bin";
import { calculateCalculate } from "./calculate";
import { filter } from "./filter";
import { flatten } from "./flatten";
import { foldData } from "./fold";
import { geocode } from "./geocoding";
import { pivot } from "./pivot";
import { sample } from "./sample";
import { lookup } from "./lookup";
import { unroll } from "./unroll";
import { addIndex } from "./addIndex";
const applyTransform = (state, data, spec, funcs) => __awaiter(void 0, void 0, void 0, function* () {
    if (spec.type === "aggregation") {
        return computeAggregation(data, spec);
    }
    else if (spec.type === "bin") {
        return computeBins(data, spec);
    }
    else if (spec.type === "calculate") {
        return calculateCalculate(data, spec);
    }
    else if (spec.type === "filter") {
        return filter(data, spec);
    }
    else if (spec.type === "flatten") {
        return flatten(data, spec);
    }
    else if (spec.type === "fold") {
        return foldData(data, spec);
    }
    else if (spec.type === "pivot") {
        return pivot(data, spec);
    }
    else if (spec.type === "sample") {
        return sample(data, spec);
    }
    else if (spec.type === "unroll") {
        return unroll(data, spec);
    }
    else if (spec.type === "lookup") {
        return lookup(data, state, spec);
    }
    else if (spec.type === "geocode") {
        return yield geocode(data, spec);
    }
    else if (spec.type === "addIndex") {
        return addIndex(data, spec);
    }
    else if (spec.type === "function") {
        return funcs[spec.function](data, spec);
    }
});
export { applyTransform };
//# sourceMappingURL=transform.js.map