import { convertVal } from "../complete";
import { rescaleLayout } from "./utils";
const computeExplicitLayout = (data, spec, state, bounds) => {
    const layout = new Map();
    const axes = [];
    for (const datum of data) {
        const x = convertVal(spec.x, datum, state);
        const y = convertVal(spec.y, datum, state);
        layout.set(datum.id, { x, y, width: 1, height: 1 });
    }
    if (spec === null || spec === void 0 ? void 0 : spec.scaleToBounds) {
        rescaleLayout(spec, state, data, layout, bounds, axes);
    }
    return [layout, axes];
};
export { computeExplicitLayout };
//# sourceMappingURL=explicitLayout.js.map