import { constructExpressionFunction } from "../data/calculate";
import { select } from "../data/select";
const connectNodes = (nodes, links, spec, state) => {
    var _a, _b;
    let getVal;
    let linkType;
    if ("field" in spec) {
        getVal = (node) => select(node, spec.field);
        linkType = (_a = spec.as) !== null && _a !== void 0 ? _a : spec.field;
    }
    else if ("expression" in spec) {
        const f = constructExpressionFunction({ calculate: spec.expression });
        getVal = node => f(node, null, state);
        linkType = (_b = spec.as) !== null && _b !== void 0 ? _b : "commonExpression";
    }
    const vals = new Map();
    for (const node of nodes) {
        const key = getVal(node);
        if (vals.has(key)) {
            vals.get(key).push(node);
        }
        else {
            vals.set(key, [node]);
        }
    }
    for (const key of vals.keys()) {
        for (const n1 of vals.get(key)) {
            for (const n2 of vals.get(key)) {
                if (n1.id !== n2.id && (n1.id < n2.id || (spec === null || spec === void 0 ? void 0 : spec.bothDirections))) {
                    links.push({ source: n1, target: n2, _type: linkType }); // TODO: need to set a link ID!
                }
            }
        }
    }
    return links;
};
export { connectNodes };
//# sourceMappingURL=connectNodes.js.map