import { constructExpressionFunction } from "../data/calculate";
const filterNodes = (network, spec, state) => {
    const f = constructExpressionFunction({ calculate: spec.expression });
    const retainedNodes = [];
    const discardedNodes = [];
    for (const node of network.nodes) {
        if (f(node, null, state)) {
            retainedNodes.push(node);
        }
        else {
            discardedNodes.push(node);
        }
    }
    network.nodes = retainedNodes;
    network.links = network.links.filter(l => retainedNodes.includes(l.source) && retainedNodes.includes(l.target));
};
export { filterNodes };
//# sourceMappingURL=filterNodes.js.map