import { select } from "../data/select";
import { constructExpressionFunction } from "../data/calculate";
const promoteField = (nodes, links, spec, state) => {
    var _a;
    let getValToPromote = (_) => true;
    if ("expression" in spec) {
        const f = constructExpressionFunction({ calculate: spec.expression });
        getValToPromote = link => f(link, null, state);
    }
    else {
        getValToPromote = (node) => select(node, spec.field);
    }
    const newNodeMap = new Map();
    let i = 0;
    const newNodes = [];
    for (const node of nodes) {
        const val = getValToPromote(node);
        let newNode;
        if (newNodeMap.has(val)) {
            newNode = newNodeMap.get(val);
        }
        else {
            newNode = { id: `${spec.prefix}${val}` }; // TODO: id? type?
            newNodeMap.set(val, newNode);
            newNodes.push(newNode);
        }
        const linkId = `${((_a = spec.linkPrefix) !== null && _a !== void 0 ? _a : spec.prefix)}${i++}`;
        if ((spec === null || spec === void 0 ? void 0 : spec.direction) === "fromValue") {
            links.push({ id: linkId, source: newNode, target: node }); // TODO: direction, id, othe rvals
        }
        else {
            links.push({ id: linkId, source: node, target: newNode }); // TODO: direction, id, othe rvals
        }
    }
    return { nodes: [...nodes, ...newNodes], links };
};
export { promoteField };
//# sourceMappingURL=promoteField.js.map