import { constructExpressionFunction } from "../data/calculate";
const setDirectedness = (nodes, links, spec, state) => {
    let isDirected = (_) => undefined;
    if ("value" in spec) {
        isDirected = () => (spec.value === "directed");
    }
    else if ("expression" in spec) {
        const f = constructExpressionFunction({ calculate: spec.expression });
        isDirected = link => f(link, null, state);
    }
    for (const link of links) {
        link.directed = !!isDirected(link);
    }
    return links;
};
export { setDirectedness };
//# sourceMappingURL=setDirectedness.js.map