const incrementCount = (map, key) => {
    if (!map.has(key)) {
        map.set(key, 0);
    }
    map.set(key, map.get(key) + 1);
};
const commonNeighbours = (state, selection, adjacency, spec) => {
    const connectionsCount = new Map();
    for (const node of selection.nodes) {
        if (spec.direction === "source" || spec.direction === "both") {
            for (const link of adjacency.inLinks.get(node.id)) {
                incrementCount(connectionsCount, link.source);
            }
        }
        if (spec.direction === "target" || spec.direction === "both") {
            for (const link of adjacency.outLinks.get(node.id)) {
                incrementCount(connectionsCount, link.target);
            }
        }
        for (const link of adjacency.undirectedLinks.get(node.id)) {
            if (link.source.id === node.id) {
                incrementCount(connectionsCount, link.target);
            }
            else {
                incrementCount(connectionsCount, link.source);
            }
        }
    }
    const commonNodes = [];
    for (const [node, numConnections] of connectionsCount) {
        if (numConnections === selection.nodes.length && !commonNodes.includes(node)) {
            commonNodes.push(node);
        }
    }
    return { links: [], nodes: commonNodes };
};
export { commonNeighbours };
//# sourceMappingURL=commonNeighbours.js.map