const connectedEdges = (state, selection, adjacency, spec) => {
    let links = [];
    for (const node of selection.nodes) {
        if (spec.direction === "source") {
            links = [...links, adjacency.inLinks.get(node.id)];
        }
        else if (spec.direction === "target") {
            links = [...links, adjacency.outLinks.get(node.id)];
        }
        else {
            links = [...links, ...adjacency.inLinks.get(node.id), ...adjacency.outLinks.get(node.id), ...adjacency.undirectedLinks.get(node.id)];
        }
    }
    links = Array.from(new Set(links));
    return { links, nodes: [] };
};
export { connectedEdges };
//# sourceMappingURL=connectedEdges.js.map