import { constructExpressionFunction } from "../data/calculate";
const filter = (state, selection, adjacency, spec) => {
    const f = constructExpressionFunction({ calculate: spec.expression });
    let nodes, links;
    if (spec.affects === "nodes") {
        const removedNodes = selection.nodes.filter((n, i) => !f(n, i)).map(n => n.id);
        // remove any links attached to removed nodes
        nodes = selection.nodes.filter(f);
        links = selection.links.filter(l => !removedNodes.includes(l.source.id) && !removedNodes.includes(l.target.id));
    }
    else {
        nodes = selection.nodes;
        links = selection.links.filter(f);
    }
    return { nodes, links };
};
export { filter };
//# sourceMappingURL=filter.js.map