const findNeighbours = (state, selection, adjacency, spec) => {
    let depth = 1;
    if (spec.depth === "infinity") {
        depth = Infinity;
    }
    else if (spec.depth) {
        depth = spec.depth;
    }
    let previousNodes = new Set(selection.nodes);
    const allNeighbours = new Set();
    const allLinks = new Set();
    for (let i = 0; i < depth; i++) {
        const neighbours = new Set();
        for (const n of previousNodes) {
            // etc.
            if (spec.direction === "in" || spec.direction === "both") {
                for (const l of adjacency.inLinks.get(n.id)) {
                    neighbours.add(l.source);
                    allNeighbours.add(l.source);
                    allLinks.add(l);
                }
            }
            if (spec.direction === "out" || spec.direction === "both") {
                for (const l of adjacency.outLinks.get(n.id)) {
                    neighbours.add(l.target);
                    allNeighbours.add(l.target);
                    allLinks.add(l);
                }
            }
            // always process undirected links
            for (const l of adjacency.undirectedLinks.get(n.id)) {
                const node = (l.source.id === n.id) ? l.target : l.source;
                neighbours.add(node);
                allNeighbours.add(node);
                allLinks.add(l);
            }
        }
        previousNodes = neighbours;
    }
    return { links: Array.from(allLinks), nodes: Array.from(allNeighbours) };
};
export { findNeighbours };
//# sourceMappingURL=neighbours.js.map