const parallelEdges = (state, selection, adjacency, spec) => {
    const network = state[selection.network];
    const nodePair = new Set();
    for (const l of selection.links) {
        nodePair.add(l.source.id + "->" + l.target.id);
    }
    let links;
    if (spec.ignoreDirection) {
        links = network.links.filter(l => nodePair.has(l.source.id + "->" + l.target.id));
    }
    else {
        links = network.links.filter(l => nodePair.has(l.source.id + "->" + l.target.id) || nodePair.has(l.target.id + "->" + l.source.id));
    }
    return { nodes: [], links };
};
export { parallelEdges };
//# sourceMappingURL=parallelEdges.js.map