const prune = (state, selection, adjacency, spec) => {
    let removedNodes, nodes;
    if (spec.remove === "roots") {
        // Remove nodes with no incoming connections
        removedNodes = selection.nodes.filter(n => adjacency.inLinks.get(n.id).length === 0);
        nodes = selection.nodes.filter(n => adjacency.inLinks.get(n.id).length > 0);
    }
    else if (spec.remove === "leaves") {
        // Remove nodes with no outgoing connections
        removedNodes = selection.nodes.filter(n => adjacency.outLinks.get(n.id).length === 0);
        nodes = selection.nodes.filter(n => adjacency.outLinks.get(n.id).length > 0);
    }
    else if (spec.remove === "isolated") {
        // Remove nodes with no outgoing connections
        removedNodes = selection.nodes.filter(n => adjacency.inLinks.get(n.id).length === 0 || adjacency.outLinks.get(n.id).length === 0);
        nodes = selection.nodes.filter(n => adjacency.outLinks.get(n.id).length > 0);
    }
    // Remove any links attached to removed nodes
    const links = selection.links.filter(l => {
        return !removedNodes.includes(l.source.id) && !removedNodes.includes(l.target.id);
    });
    return { nodes, links };
};
export { prune };
//# sourceMappingURL=prune.js.map