import { Layout } from "webcola";
// based on https://github.com/tgdwyer/WebCola/blob/2b6a7564d6e2dde0080870b051eda89e82f78ad9/WebCola/test/apitests.ts#L30
// adds index, x, y attributes to node array
// note that .source/.target attribute on links must be an index or object (not an id, which d3-force would accept)
const layoutCola = (nodes, links, spec) => {
    // @ts-ignore
    const layout = new Layout()
        .linkDistance(spec.linkDistance === undefined ? 2 : spec.linkDistance)
        // @ts-ignore
        .nodes(nodes)
        // @ts-ignore
        .links(links);
    if (spec.constraints !== undefined) {
        layout.constraints(spec.constraints);
    }
    if (spec.avoidOverlap !== undefined) {
        layout.avoidOverlaps(spec.avoidOverlap);
    }
    if (spec.handleDisconnected !== undefined) {
        layout.handleDisconnected(spec.handleDisconnected);
    }
    if (spec.convergenceThreshold !== undefined) {
        layout.convergenceThreshold(spec.convergenceThreshold);
    }
    if (spec.flowLayout) {
        layout.flowLayout(spec.flowLayout.axis, spec.flowLayout.minSeparation);
    }
    if (spec.jaccardLinkLength) {
        layout.jaccardLinkLengths(spec.jaccardLinkLength);
    }
    if (spec.symmetricDiffLinkLength) {
        layout.symmetricDiffLinkLengths(spec.symmetricDiffLinkLength);
    }
    if (spec.defaultNodeSize) {
        layout.defaultNodeSize(spec.defaultNodeSize);
    }
    layout.start(100);
};
export { layoutCola };
//# sourceMappingURL=layoutCola.js.map