var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
const layoutTulip = (nodes, links, spec) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    const body = {
        network: {
            nodes: nodes,
            links: links.map(l => ({ source: l.source.id, target: l.target.id }))
        },
        options: Object.assign({ algorithm: spec.algorithm }, (spec.options || []))
    };
    let server = (_a = spec.server) !== null && _a !== void 0 ? _a : "http://localhost:8080";
    server = server.endsWith("/") ? server : server + "/";
    return yield fetch(server + "layout", {
        method: "POST",
        mode: "cors",
        body: JSON.stringify(body),
        headers: {
            "Content-Type": "application/json"
        }
    })
        .then(res => res.json());
});
export { layoutTulip };
//# sourceMappingURL=layoutTulip.js.map