export const addAxes = (spec, scene, parentState) => {
    if ("drawAxes" in spec && spec.drawAxes) {
        for (const axis of parentState[spec.layout + "_AXES"]) {
            if (axis.type === "cartesian") {
                scene.items[0].items.push({
                    marktype: "rule",
                    items: [
                        {
                            stroke: "black",
                            x: axis.x,
                            x2: axis.x2,
                            y: axis.y,
                            y2: axis.y2
                        }
                    ]
                });
                if (axis.extend === "x") {
                    // ticks are vertical
                    for (const tick of axis.ticks) {
                        scene.items[0].items.push({
                            marktype: "rule",
                            items: [
                                {
                                    stroke: "black",
                                    x: tick.x,
                                    x2: tick.x,
                                    y: tick.y - 5,
                                    y2: tick.y + 5
                                }
                            ]
                        });
                        scene.items[0].items.push({
                            marktype: "text",
                            items: [
                                {
                                    fill: "black",
                                    text: tick.label,
                                    x: tick.x,
                                    y: tick.y - 15
                                }
                            ]
                        });
                    }
                }
                else if (axis.extend === "y") {
                    // ticks are horizontal
                    for (const tick of axis.ticks) {
                        scene.items[0].items.push({
                            marktype: "rule",
                            items: [
                                {
                                    stroke: "black",
                                    x: tick.x - 5,
                                    x2: tick.x + 5,
                                    y: tick.y,
                                    y2: tick.y
                                }
                            ]
                        });
                        scene.items[0].items.push({
                            marktype: "text",
                            items: [
                                {
                                    fill: "black",
                                    text: tick.label,
                                    x: tick.x - 15,
                                    y: tick.y
                                }
                            ]
                        });
                    }
                }
            }
            else if (axis.type === "polar") {
                scene.items[0].items.push({
                    marktype: "arc",
                    items: [
                        {
                            fill: "black",
                            x: axis.x,
                            y: axis.y,
                            startAngle: 0,
                            endAngle: 2 * Math.PI,
                            innerRadius: axis.r,
                            outerRadius: axis.r
                        }
                    ]
                });
            }
        }
    }
};
//# sourceMappingURL=axes.js.map