import { computeBins } from "./bin";

test("can compute bins", () => {

  // example from https://vega.github.io/vega/docs/transforms/bin/

  const data = [
    { "amount": 3.7 },
    { "amount": 6.2 },
    { "amount": 5.9 },
    { "amount": 8 }
  ];

  const spec = {
    type: "bin",
    field: "amount"
  };

  const binned = computeBins(data, spec);
  expect(binned).toEqual([
      { amount: 3.7, bin0: 2, bin1: 4 },
      { amount: 5.9, bin0: 4, bin1: 6 },
      { amount: 6.2, bin0: 6, bin1: 8 },
      { amount: 8, bin0: 8, bin1: 10 }
    ]
  );
});


test("can compute bins, with more than one item per bin ", () => {
  const data = [
    { "amount": 3.7 },
    { "amount": 3.7 },
    { "amount": 6.2 },
    { "amount": 5.9 },
    { "amount": 8 }
  ];

  const spec = {
    type: "bin",
    field: "amount"
  };

  const binned = computeBins(data, spec);

  expect(binned).toEqual([
      { amount: 3.7, bin0: 3, bin1: 4 },
      { amount: 3.7, bin0: 3, bin1: 4 },
      { amount: 5.9, bin0: 5, bin1: 6 },
      { amount: 6.2, bin0: 6, bin1: 7 },
      { amount: 8, bin0: 8, bin1: 9 }
    ]
  );
});

