import { calculateCalculate } from "./calculate";

test("can calculate new field", () => {
  // This example is from https://vega.github.io/vega-lite/docs/calculate.html

  const data = [
    { "a": "A", "b": 28 },
    { "a": "B", "b": 55 },
    { "a": "C", "b": 43 },
    { "a": "G", "b": 19 },
    { "a": "H", "b": 87 },
    { "a": "I", "b": 52 },
    { "a": "D", "b": 91 },
    { "a": "E", "b": 81 },
    { "a": "F", "b": 53 }
  ];

  const spec = { "calculate": "2*datum.b", "as": "b2" };

  const res = calculateCalculate(data, spec);

  expect(res).toEqual([
      { a: "A", b: 28, b2: 56 },
      { a: "B", b: 55, b2: 110 },
      { a: "C", b: 43, b2: 86 },
      { a: "G", b: 19, b2: 38 },
      { a: "H", b: 87, b2: 174 },
      { a: "I", b: 52, b2: 104 },
      { a: "D", b: 91, b2: 182 },
      { a: "E", b: 81, b2: 162 },
      { a: "F", b: 53, b2: 106 }
    ]
  );
});