import { filter } from "./filter";

test("can filter a data array", () => {
  const data = [
    { x: 1 },
    { x: 2 },
    { x: 3 },
    { x: 4 },
    { x: 5 }
  ];

  const spec1 = { "type": "filter", "expr": "datum.x > 3" };
  const res1 = filter(data, spec1);
  expect(res1).toEqual([{ x: 4 }, { x: 5 }]);


  const spec2 = { "type": "filter", "expr": "datum.x < 3" };
  const res2 = filter(data, spec2);
  expect(res2).toEqual([{ x: 1 }, { x: 2 }]);
});


test("can filter based on nested data", () => {
    const data = [
      {foo: { x: 1 }},
    {foo: { x: 2 }},
    {foo: { x: 3 }},
    {foo: { x: 4 }},
    {foo: { x: 5 }}
  ];

      const spec1 = { "type": "filter", "expr": "datum.foo.x > 3" };
  const res1 = filter(data, spec1);
  expect(res1).toEqual([ {foo: { x: 4 }},
    {foo: { x: 5 }}]);


})