import { flatten } from "./flatten";

test("can flatten array", () => {
  // example from https://vega.github.io/vega-lite/docs/flatten.html

  const spec = { "flatten": ["foo", "bar"] };

  const data = [
    { "key": "alpha", "foo": [1, 2], "bar": ["A", "B"] },
    { "key": "beta", "foo": [3, 4, 5], "bar": ["C", "D"] }
  ];

  const res = flatten(data, spec);

 // console.log(res)
  expect(res).toEqual(
    [
      { "key": "alpha", "foo": 1, "bar": "A" },
      { "key": "alpha", "foo": 2, "bar": "B" },
      { "key": "beta", "foo": 3, "bar": "C" },
      { "key": "beta", "foo": 4, "bar": "D" },
      { "key": "beta", "foo": 5, "bar": undefined } // example on Vega-Lite site return null rather than undefined
    ]
  );
});
