import { geocode } from "./geocoding";

// import {fetch} from "node-fetch";

beforeEach(() => { // if you have an existing `beforeEach` just add the following lines to it

  /*
  fetchMock.mockIf(/^https?:\/\/geocode.maps.co.*$/, req => {

      if (req.url.endsWith("/postalcode=EH8%209AB")) {
        return [{"place_id":289944992,"licence":"Data © OpenStreetMap contributors, ODbL 1.0. https://osm.org/copyright","boundingbox":["55.78471","56.10471","-3.34742","-3.02742"],"lat":"55.94471","lon":"-3.18742","display_name":"Southside, City of Edinburgh, Scotland, EH8 9AB, United Kingdom","class":"place","type":"postcode","importance":0.325}];

      } else if (req.url.endsWith("/postalcode=OX1%202JD")) {
        return [{"place_id":289460633,"licence":"Data © OpenStreetMap contributors, ODbL 1.0. https://osm.org/copyright","boundingbox":["51.598386425","51.918386425","-1.4217553353547","-1.1017553353547"],"lat":"51.758386425","lon":"-1.2617553353546909","display_name":"University Offices, City Centre, Oxford, Oxfordshire, South East England, England, OX1 2JD, United Kingdom","class":"place","type":"postcode","importance":0.325}]
      } else {
        return {
          status: 404,
          body: "Not Found"
        }
      }
  })

   */


  const res1 = [{"place_id":289944992,"licence":"Data © OpenStreetMap contributors, ODbL 1.0. https://osm.org/copyright","boundingbox":["55.78471","56.10471","-3.34742","-3.02742"],"lat":"55.94471","lon":"-3.18742","display_name":"Southside, City of Edinburgh, Scotland, EH8 9AB, United Kingdom","class":"place","type":"postcode","importance":0.325}];
  fetchMock.get("https://geocode.maps.co/postalcode=EH8%209AB", res1);

  const res2 = [{"place_id":289460633,"licence":"Data © OpenStreetMap contributors, ODbL 1.0. https://osm.org/copyright","boundingbox":["51.598386425","51.918386425","-1.4217553353547","-1.1017553353547"],"lat":"51.758386425","lon":"-1.2617553353546909","display_name":"University Offices, City Centre, Oxford, Oxfordshire, South East England, England, OX1 2JD, United Kingdom","class":"place","type":"postcode","importance":0.325}]
  fetchMock.get("https://geocode.maps.co/postalcode=OX1%202JD", res2);


})


test.skip("can geocode", async () => {
  const data = [
    { "postcode": "EH8 9AB" },
    { "postcode": "OX1 2JD" }
  ];


  const res = await geocode(data, { postalCodeField: "postcode" });
  expect(res[0].lon).toEqual("-3.18742");
  expect(res[0].lat).toEqual("55.94471");

  expect(res[0].lon).toEqual("-1.2617553353546909");
  expect(res[0].lat).toEqual("51.758386425");

});

test.skip("can use custom names for lon and lat", async () => {
  const data = [
    { "postcode": "EH8 9AB" }
  ];

  const res = await geocode(data, { postalCodeField: "postcode", latAs: "latitude", lonAs: "longitude" });
  expect(res[0].longitude).toEqual("-3.18742");
  expect(res[0].latitude).toEqual("55.94471");
});

