import type { LookupSpec } from "../types/data-transforms";

const lookup = (data, state, spec: LookupSpec) => {

  data = JSON.parse(JSON.stringify(data));

  // first collect the values
  const values = {};

  if (!spec.values) {
    for (const dataRow of state[spec.from]) {
      const keyVal = dataRow[spec.key];
      values[keyVal] = dataRow;
    }
  } else {

    for (const field of spec.values) {
      values[field] = {};
    }

    for (const dataRow of state[spec.from]) {
      const keyVal = dataRow[spec.key];

      for (const field of spec.values) {
        values[field][keyVal] = dataRow[field];
      }
    }
  }


  // then add them
  for (const dataRow of data) {

    if (!spec.values) {
      const keyVal = dataRow[spec.fields[0]];
      dataRow[spec.as[0]] = values[keyVal];
    } else {

       let i = 0;

      for (const field of spec.values) {
        const name = (spec.as || [])[i] || field;
        const keyVal = dataRow[spec.fields[0]];

        const val = values[field][keyVal];
        dataRow[name] = (typeof(val) === "undefined" )? spec.default : val;

        i += 1;

      }
    }


  }

  return data;
};

export { lookup };