// N.B.
// - currently only attaches the fist match
// - should be more generic, to allow references to deeper nesting
// - the repeated iteration over data elements during joins is inefficient: for large datasets it would be more efficient to first construct an index for the field being used to join


function addRelationships(data: any, relationships: string[][]) {
    for (const relationship of relationships) {
        addRelationship(data, relationship);
    }
}

function addRelationship(data: any, relationship: string[]) {
    const relationshipName = relationship[0];
    const [datasetName, firstField] = relationship[1].split('.');
    const [foreignDatasetName, secondField] = relationship[2].split('.');

    const dataset = data[datasetName];
    const secondDataset = data[foreignDatasetName]
    for (const entry of dataset) {
        const matches = secondDataset.filter((d: any) => d[secondField] === entry[firstField]);
        if (matches.length > 0) {
            entry[relationshipName] = matches[0];
        } else {
            entry[relationshipName] = null;
        }
    }
}

export {addRelationship, addRelationships}