// This has a fixed n: Vega uses reservoir sampling to more efficiently handle changes in number of items selected

import type { SampleSpec } from "../types/data-transforms";

function getRandomInt(min, max) {
  min = Math.ceil(min);
  max = Math.floor(max);
  return Math.floor(Math.random() * (max - min) + min); //The maximum is exclusive and the minimum is inclusive
}

const sample = (data: any[], spec: SampleSpec) => {

  if (data.length < spec.sample) {
    return data;
  }

  const results = [];
  const indexes = [];

  while (results.length < spec.sample) {

    const i = getRandomInt(0, data.length);

    if (!indexes.includes(i)) {
      results.push(data[i]);
      indexes.push(i);
    }
  }

  return results;

};

export { sample };