import { select } from "./select";

test("basic select works", () => {
    const ex1 = {
        foo: {
            bar: {
                x: 4,
                y: 7
            }
        }
    }

    expect(select(ex1, "foo")).toEqual({
        bar: {
            x: 4,
            y: 7
        }
    })
})

test("deeper select works", () => {
    const net = {
        nodes: [
            {x: 1, y: 2, data: {prices: [1, 2, 3]}},
            {x: 3, y: 3, data: {prices: [4, 5, 6]}}
        ]
    }

    expect(select(net, "nodes.data")).toEqual([{"prices": [1, 2, 3]}, {"prices": [4, 5, 6]}]);
    expect(select(net, "nodes.data.prices")).toEqual([1, 2, 3, 4, 5, 6]);
})
