import { determineEvaluationOrder } from "./dependencyGraph";

test("can determine what to re-evaluate", () => {

  const dependencyGraph = [
    { name: "data", dependencies: [] },
    { name: "network", dependencies: ["data"] },
    { name: "scale", dependencies: [] },
    { name: "layout", dependencies: ["data"] },
    { name: "vis", dependencies: ["scale", "layout", "network"] }
  ];

  const res = determineEvaluationOrder(dependencyGraph, ["data"]);

  expect(res).toEqual([
    { "name": "data", "dependencies": [] },
    { "name": "network", "dependencies": ["data"] },
    { "name": "layout", "dependencies": ["data"] },
    { "name": "vis", "dependencies": ["scale", "layout", "network"] }
  ]);
});


test("no propogation after invalidation of stage that is not a dependency", () => {

  const dependencyGraph = [
    { name: "data", dependencies: [] },
    { name: "data2", dependencies: [] },
    { name: "network", dependencies: ["data"] },
    { name: "scale", dependencies: [] },
    { name: "layout", dependencies: ["data"] },
    { name: "vis", dependencies: ["scale", "layout", "network"] }
  ];

  const res = determineEvaluationOrder(dependencyGraph, ["data2"]);

  expect(res).toEqual([
    { "name": "data2", "dependencies": [] }
  ]);
});