// Website has several examples:
// les mis
// northwind
// chinook
// movies
// twitter, politics
// air travel


//import * as bechedel from "../../example_datasets/origraph/movies/data_files/bechdel.json"

import {unroll} from "../data/unroll";

let bechedel = require("../../../editor/public/data/origraph/movies/data_files/bechdel.json");
const credits = require("../../../editor/public/data/origraph/movies/data_files/credits.json");
const movies = require("../../../editor/public/data/origraph/movies/data_files/movies.json");
const people = require("../../../editor/public/data/origraph/movies/data_files/people.json");


const linkData = (data, extraData, dataLinkingField, extraDataLinkingField) => {
  // TODO: extra options
  // TODO: specify which values to add (and with what names)
  // TODO: alternative behaviour would be to add this data object as an attribute, rather than adding each value as an attribute


  const extraValues = [];
  for (const extraDataRow of extraData){
    const {[extraDataLinkingField]: value, ...values}  = extraDataRow;
    extraValues[ extraDataRow[extraDataLinkingField] ] = values;
  }

  for (let dataRow of data){
      dataRow = {...dataRow, ...extraValues[ dataRow[dataLinkingField] ]}
  }

}

test("can load the data files", () => {
  expect(bechedel).toHaveLength(7871);
  expect(credits).toHaveLength(50);
  expect(movies).toHaveLength(50);
  expect(people).toHaveLength(8951);
});




// The example in Fig 8 of the origrpah paper adds network between movies and people, linking with cast

test("can assemble the network", () => {

  // Link Movies-cast-peole
  // Link Movies-crew-people
  // link movies- (produced by) - companies
  // link movies - (has score) - bechedel tests


  // Our first objective is to combine the Bechdel
  // and TMDB data about movies.

  // TODO: do this stage sing the grammar
  bechedel = bechedel.map(entry => ({ ...entry, imdbid_tt: "tt" + entry.imdbid }));

  // add data from bechedels table to imdb table
  // N.B., rather than doing this, could add a relationship and then access values as ".bechedel.score"
  // TODO: think about whether or not this is better
  linkData(movies, bechedel, "imdb_id", "imdbid_tt" )


  // "We then unroll nested cast and crew objects as distinct classes (Figure M7)"
   const {cast, crew} = unroll(credits, {fields: ["cast", "crew"]})
  // console.log(cast[0])



  //
  //
  // convert people to
  // nodes, cast and crew to edges (Figure M8), and then connect both
  // cast and crew to people and movies (Figure M9).

  // we're luck here that there is already an id field
  //  id in cast/crew arrays = id in people
  // movie_id in cast/crew arrays = id in movies array

  // we have two node types, each with its own set of IDs, which need to be unified

  // [can either "connect via" a link table, or do two connections and a projection]

  // TODO: think about handling these IDs when doing multiple joins
  // one option is for graph constructor to accept multiple node arrays and link conditions, and just handle it internally

  // we can construct netwrok with nodes



//console.log(movies[0])

});



/*

// Thinking abstractly, we can replace a long stream of operation with three stages:
// pre-processing [acts on data tables]
// network construction [converts tables to network]
// network processing [consists of operations which require the data to be in network form]

// pre-process by merging data from movie and bechedel tables
// reformat the credits data

// movies: MOVIES objects, connected to PRODUCTION_COMPANIES defined by production_companies array
// people: PEOPLE objects, linked to MOVIES

// then do "connectivity-based attribute derivation" to calculate gender bias


// parsing an object which has a lsit of connected entities as a attribute is common
// maybe support this directly, without needing to "unroll"

 */

/*
Operations:

Modelling:
* converting between nodes and edges [they mean converting between a bipartite network and a network with a single node type but data on edges - an alternative is simply inverting nodes and edges]
* edge-projection
* aggregation into supernodes
* rolling up edges

Item operations:

* filtering by attributes
* connectivity based filtering

Attribute operations:

* deriving new attributes
* connectivity based attribute derivation
changing edge directionalit



 */