let allContributions = require("../../../editor/public/data/origraph/politics/allContributions.json");
let pressReleases = require("../../../editor/public/data/origraph/politics/pressReleases.json");
let senate_votes_yemen = require("../../../editor/public/data/origraph/politics/senate_votes_yemen.json");
let senateMembers = require("../../../editor/public/data/origraph/politics/senateMembers.json");
let senateTweets = require("../../../editor/public/data/origraph/politics/senateTweets.json");


test("can load the data files", () => {
  expect(allContributions).toHaveLength(3269);
  expect(pressReleases).toHaveLength(20);
  expect(senate_votes_yemen).toHaveLength(100);
  expect(senateTweets).toHaveLength(2188);
});

test("can assemble the network", () => {

  // connect senators to tweets: join on tweet.user.screen_name === senateMembers.twitter_account
  // connect senators to votes: vote.member_id = senateMembers.id
  // connect senators to press releases: press_release.member_id == senateMembers.id
  // connect senators to donations: contribution.candidate == senateMembers.fec_candidate_id


  // Subsequent changes:
  // facet votes into yes or no based on `vote_position` [why?]

  // promote contribution.fec_committee_name: nodes are fec_committee_name, and edges joi these to candidates
  // in other words, allContributions is a link table

  // connecting senators to their votes, their press releases, and
  // any donations

});

// There are too many operations here like "converting", "faceting", "promoting"

// Thinking more abstractly about this, think about what is extracted from each table

// senators: new SENATOR nodes
// votes: link between SENATOR identified by `member_id` and new VOTE nodes identified by `vote_position` field [this implicitly defines a set of VOTE nodes with no other details than label]
// press releases: link between SENATOR nodes and new PRESS_RELEASE nodes
// contributions: link between  SENATOR nodes (identified by candidate id) and new COMMITTEE nodes identified by `fec_committee_name` [again, implicitly created]
  // for/against set by node color


// we also have the links from committees and votes: this is a projection on committee-senator-vote, preserving the for/against value of the contribution edge [but the projection adds new edges, rather than replacing existing ones]

