import { Axis, DerivedLayout, Layout } from "../types/layout";
import { Bounds } from "../types/spec";
import { transformLayout } from "./layoutTransforms";
import { select } from "../data/select";


const computeDerivedLayout = (state, spec: DerivedLayout, bounds: Bounds, funcs): [Layout, Axis[]] => {
  const layout: Layout = select(state, spec.source);
  const axes: Axis[] = [];

  let l = layout;
  for (const layoutTransform of (spec?.transform || [])) {
    l = transformLayout(layoutTransform, spec, l, state, funcs);
  }

  return [l, axes];
};

export { computeDerivedLayout };
