import type { AttributeLayoutExplicit, Axis, Layout } from "../types/layout";
import type { Bounds } from "../types/spec";
import { convertVal } from "../complete";
import { rescaleLayout } from "./utils";

const computeExplicitLayout = (data: any[], spec: AttributeLayoutExplicit, state, bounds: Bounds): [Layout, Axis[]] => {
  const layout: Layout = new Map();
  const axes: Axis[] = [];

  for (const datum of data) {
    const x = convertVal(spec.x, datum, state);
    const y = convertVal(spec.y, datum, state);
    layout.set(datum.id, { x, y, width: 1, height: 1 });
  }

  if (spec?.scaleToBounds){
      rescaleLayout(spec, state, data, layout, bounds, axes);
  }

  return [layout, axes];
};

export { computeExplicitLayout };