import { constructExpressionFunction } from "../data/calculate";
import { FilterNodeSpec } from "../types/networkTransforms";


const filterNodes = (network, spec: FilterNodeSpec, state: any) => {
    const f = constructExpressionFunction({calculate: spec.expression});

    const retainedNodes = [];
    const discardedNodes = [];

    for (const node of network.nodes){
        if (f(node, null, state)){
            retainedNodes.push(node);
        } else {
            discardedNodes.push(node);
        }
    }

    network.nodes = retainedNodes;
    network.links = network.links.filter(l => retainedNodes.includes(l.source) && retainedNodes.includes(l.target));
};

export {filterNodes}