import {removeIsolatedNodes} from "./removeIsolatedNodes";
import { constructNetwork } from "./creation/constructNetwork";

test("removes isolated nodes", () => {


    let data = {};

  data.nodes = [
    { id: 0, name: "foo" },
    { id: 1, name: "bar" },
    { id: 2, name: "foo-bar" }
  ];

  data.links = [
    { source_id: 0, target_id: 1 },
    { source_id: 1, target_id: 0 }
  ];

  const network = constructNetwork(data, {
    nodes: "nodes",
    links: "links",
    directed: true,
    source_node: ["id", "source_id"], // node.id == link.source_id
    target_node: ["id", "target_id"]
  });

  expect(network.nodes).toEqual([
    { id: 0, name: "foo" },
    { id: 1, name: "bar" },
    { id: 2, name: "foo-bar" }
  ])

  removeIsolatedNodes(network);

    expect(network.nodes).toEqual([
    { id: 0, name: "foo" },
    { id: 1, name: "bar" }
  ]);

})