import { constructExpressionFunction } from "../data/calculate";
import type { ReverseEdgesSpec } from "../types/networkTransforms";

const reverseEdges = (nodes, links, spec: ReverseEdgesSpec, state) => {

  let conditionApplies = (_) => true;
  if ("condition" in spec) {
    const f = constructExpressionFunction({ calculate: spec.condition });
    conditionApplies = link => f(link, null, state);
  }


  for (const link of links) {

    if (conditionApplies(link)) {
      const source = link.source;
      link.source = link.target;
      link.target = source;
    }
  }

  return links;
};

export { reverseEdges };
