import type { Adjacency } from "./constructAdjacencyList";
import type { Selection, TransformConnectedNodes } from "../types/params";


const connectedNodes = (state, selection: Selection, adjacency: Adjacency, spec: TransformConnectedNodes) => {
  let nodes;

  if (spec.direction === "source") {
    nodes = selection.links.map(l => l.source);
  } else if (spec.direction === "target") {
    nodes = selection.links.map(l => l.target);
  } else {
    nodes = [...selection.links.map(l => l.source), ...selection.links.map(l => l.source)];
  }

  return { links: [], nodes };
};

export { connectedNodes };
