import { constructExpressionFunction } from "../data/calculate";
import type { Adjacency } from "./constructAdjacencyList";
import type { TransformFilter } from "../types/params";
import type { Selection } from "../types/params";

const filter = (state, selection: Selection, adjacency: Adjacency, spec: TransformFilter)  => {
  const f = constructExpressionFunction({calculate: spec.expression});

  let nodes, links;
  if (spec.affects === "nodes"){
    const removedNodes = selection.nodes.filter( (n,i) => !f(n, i)).map(n => n.id);

    // remove any links attached to removed nodes
    nodes = selection.nodes.filter(f)
    links = selection.links.filter(l => !removedNodes.includes(l.source.id) && !removedNodes.includes(l.target.id))

  } else {
    nodes = selection.nodes;
    links = selection.links.filter(f);
  }

  return {nodes, links}
};

export {filter};