import type { LiteralOrFieldOrExpression } from "../types/topologicalLayoutD3Force";
import { constructExpressionFunction } from "../data/calculate";

export const getVal = (valSpec: LiteralOrFieldOrExpression | undefined, defaultValue: number) => {
  // Some parameters for a force may be accessor functions of either the nodes or links,
  // rather than numbers that are th same for all nodes/links
  //  N.B. expression should refer to "datum"

  if (typeof (valSpec) === "undefined") {
    return defaultValue;
  } else if (typeof (valSpec) === "number") {
    return valSpec;
  } else if ("expression" in valSpec) {
    return constructExpressionFunction({ calculate: valSpec.expression });
  } else if ("field" in valSpec) {
    return (n) => n[valSpec.field];
  }
};