import {layoutCola} from "./layoutCola";
import {addRelationships} from "../data/relationships";

test("cola layout runs", () => {


    const nodes = [
        {"id": "Alice"},
        {"id": "Bob"},
        {"id": "Carol"}
    ];

    const links = [
        {"source": "Alice", "target": "Bob"}, // Alice → Bob
        {"source": "Bob", "target": "Carol"} // Bob → Carol
    ];

    const data = {nodes, links};

    // note that this is needed for cola, but not for d3-force
    addRelationships(data, [
        ["source", "links.source", "nodes.id",],
        ["target", "links.target", "nodes.id",]
    ]);


    /*
    const nodes = [
        {"name": "a", "group": 1},
        {"name": "b", "group": 1},
        {"name": "c", "group": 1},
        {"name": "d", "group": 1}
    ];
   const links =  [
        {"source": 0, "target": 1, "value": 1},
        {"source": 1, "target": 2, "value": 1},
        {"source": 2, "target": 0, "value": 1},
        {"source": 2, "target": 3, "value": 1}
    ];

   */


  //  console.log({nodes, links})


    layoutCola(nodes, links, {})

    expect(nodes).toHaveLength(3);

    const allXcoordsNumbers = nodes.every(n => typeof (n.x) === 'number')
    expect(allXcoordsNumbers).toBe(true)

    const allYcoordsNumbers = nodes.every(n => typeof (n.y) === 'number')
    expect(allYcoordsNumbers).toBe(true)
})

