import {layoutCytoscape} from "./layoutCytoscape";


const doLayout = (spec) => {
    const nodes = [
        {"id": "Alice"},
        {"id": "Bob"},
        {"id": "Carol"}
    ];

    const links = [
        {"source": "Alice", "target": "Bob"}, // Alice → Bob
        {"source": "Bob", "target": "Carol"} // Bob → Carol
    ];

    return layoutCytoscape(nodes, links, spec)
}

test.skip("cytoscape runs", () => {


    const algorithms = [
        "grid", "circle", "concentric",
        "dagre",
        "breadthfirst",
        "concentric",
        //"elk", // "TypeError: Cannot read properties of null (reading 'je')".
        "klay",
        "cose",
        "cola",
        "cise",
        "spread",

        "avsdf",
        // "fcose", // - "ReferenceError: self is not defined" - https://github.com/iVis-at-Bilkent/cytoscape.js-fcose/issues/52
        "cose-bilkent",
        // "euler", // crashes unless positions initialized: https://github.com/cytoscape/cytoscape.js-euler/issues/21
    ];

    // See also:
    // https://github.com/cytoscape/cytoscape.js-elk/issues/25 - the self is not defined issue in a different repo
    // https://github.com/cytoscape/cytoscape.js-cose-bilkent/issues/106 - the ani.play issue


    for (const algorithm of algorithms) {
        // console.log("Trying:", algorithm)

        let spec = {
            algorithm,
            animate: false
        }


        const positions = doLayout(spec)
        expect(positions).toHaveLength(3);

        const allXcoordsNumbers = positions.every(n => typeof (n.x) === 'number')
        expect(allXcoordsNumbers).toBe(true)

        const allYcoordsNumbers = positions.every(n => typeof (n.y) === 'number')
        expect(allYcoordsNumbers).toBe(true)
    }


    //console.log(nodes);
// running the layout results in nodes having fields: index, x, y, vx, vy


})

