import type { LayoutSpecBase } from "./topologicalLayout";

export type LayoutSpecTulip = LayoutSpecBase & {
  /**
   * Use a layout algorithm implemented by the Tulip framework.
   */
  type: "tulip";

  /**
   * The name of the layout algorithm to use.
   */
  algorithm: string;

  /**
   * The address of the Tulip layout server
   * (default is http://localhost:8080)
   */
  server?: string;

  /**
   * Object of options for layout algorithm.
   */
  options?: {
    [field: string]: string | number;
  }
}